<template>
	<div>
		<h2>Data Update: 03/31/2020</h2>
		<h3>Running Some Code Cleanup</h3>
		<div>
		<svg
			:width='width'
			:height='height'>
		</svg>
		</div>
	</div>
</template>

<script>
	import * as d3 from 'd3'
	export default {
		name: "Chart",
		props: {
			chart_data: Array
		},
		watch: {
			chart_data(new_value){
				this.x_scale = d3.scaleTime()
					.domain([d3.min(new_value, this.t2d), d3.max(new_value, this.t2d)])
					.range([0, this.chart_width]);

				this.updateChart(this.charts.population, new_value);
				this.updateChart(this.charts.growth, new_value);
				this.updateChart(this.charts.avoid, new_value);

				this.renderChart_Disruption(new_value);
			}
		},
		data() {
			return {
				width: 900,
				chart_height:150,
				margins: {
					left: 75,
					right: 10,
					top: 10,
					bottom: 30
				},
				charts: {
					population: null,
					growth: null,
					avoid: null,
					disruption: null
				},
				x_scale: null
			}
		},
		computed: {
			chart_width: function(){
				return this.width - this.margins.left - this.margins.right;
			},
			height: function(){
				return this.margins.top + 4*(this.chart_height+this.margins.bottom)
			}
		},
		mounted() {
			let svg = d3.select("svg")
				.attr("class","chart");

			// POPULATION
			let plots = [
				{
					"name":"Probable",
					"legend": "Cumulative Probable Cases In The US To Date",
					"color": "#ffae6e"
				},
				{
					"name":"Resolved",
					"legend": "Cumulative Resolved Cases In The US To Date",
					"color": "#99ff8c"
				},
				{
					"name":"Active",
					"legend": "Present Number of Active (Contagious) Cases In The US",
					"color": "#ff506d"
				},
			];
			this.charts.population = this.setupChart(plots, 0);

			// GROWTH
			plots = [
				{
					"name": "Growth Rate",
					"legend": "Growth Rate",
					"color": "#f7fffc"
				}
			];
			this.charts.growth = this.setupChart(plots, 1);

			// DISRUPTION
			this.charts.disruption = svg.append("g");

			// AVOID
			plots = [
				{
					"name": "Avoid Crowd Of",
					"legend": ">1% Chance of Exposure If You're In A Crowd Of...",
					"color": "#fff975"
				}
			];
			this.charts.avoid = this.setupChart(plots, 3);

		},
		methods: {
			t2d(d){
				return new Date(d['timestamp']);
			},

			setupChart(plot_profiles, y_slot){

				let y = this.margins.top+ y_slot * (this.chart_height+this.margins.bottom);

				let svg = d3.select("svg");

				let chart_obj = {
					plot_profiles: plot_profiles,
					g: svg.append("g"),
					y_scale: null,
					x_axis: d3.axisBottom(),
					y_axis: d3.axisLeft(),
					x_axis_group: null,
					y_axis_group: null,
					lines: {}
				};

				// SCALES
				// x_scale defined for entire on this

				chart_obj.y_scale = d3.scaleLinear()
					.range([this.chart_height, 0]);

				// AXES
				chart_obj.x_axis_group = chart_obj.g.append('g')
					.attr("transform", "translate(0," + this.chart_height + ")");

				chart_obj.y_axis_group = chart_obj.g.append('g');

				let thys = this;
				chart_obj.plot_profiles.forEach(function(plot_profile){
					chart_obj.lines[plot_profile['name']] = d3.line()
						.x(function (d) {
							return thys.x_scale(thys.t2d(d));
						})
						.y(function (d) {
							return chart_obj.y_scale(d[plot_profile['name']]);
						});
				});

				chart_obj.g.attr("transform", "translate("+this.margins.left+","+y+")");

				return chart_obj;
			},

			updateChart(chart_obj, plot_data) {
				if(chart_obj == null){
					console.log("updateChart before setupChart");
					return;
				}

				console.log(chart_obj);
				chart_obj.x_axis.scale(this.x_scale);

				let y_max = d3.max(plot_data, function (d) {
						return d3.max(chart_obj.plot_profiles, function(plot_profile){
							return d[plot_profile['name']];
						});
					});

				chart_obj.y_scale
					.domain([0, y_max]);

				console.log("YMAX", y_max);

				chart_obj.y_axis.scale(chart_obj.y_scale);

				chart_obj.x_axis_group.call(chart_obj.x_axis);

				chart_obj.y_axis_group.call(chart_obj.y_axis);

				console.log("PROFILES", chart_obj.plot_profiles);
				chart_obj.g.selectAll("path.trace")
					.data(chart_obj.plot_profiles)
					.enter()
					.append("path")
					.attr("class", "trace")
					.attr("d", function(plot_profile){
						let line = chart_obj.lines[plot_profile['name']];
						return line(plot_data);
					})
					.attr("stroke", function(plot_profile){
						return plot_profile['color'];
					})
					.attr("stroke-width", 2)
					.attr("fill", "none");
			},

			renderChart_Population(plot_data){
				console.log(plot_data);
				/*

				let chart_width = this.width - this.margins.left - this.margins.right;

				function t2d(d){
					return new Date(d['timestamp']);
				}

				let x_scale = d3.scaleTime()
					.domain([d3.min(plot_data, t2d), d3.max(plot_data, t2d)])
					.range([0, chart_width]);

				let y_scale = d3.scaleLinear()
					.domain([0, d3.max(plot_data, function (d) {
						return d['Probable'];
					})])
					.range([this.chart_height, 0]);

				let x_axis = d3.axisBottom()
					.scale(x_scale);

				let y_axis = d3.axisLeft()
					.scale(y_scale);

				this.charts.population.append('g')
					.attr("transform", "translate(0," + this.chart_height + ")")
					.call(x_axis);

				this.charts.population.append('g').call(y_axis);


				function getLine(chart_name) {
					let line = d3.line()
						.x(function (d) {
							return x_scale(t2d(d));
						})
						.y(function (d) {
							return y_scale(d[chart_name]);
						});

					return line;
				}

				var tooltip = d3.select("body").append("div")
					.attr("class", "tooltip")
					.attr("style", "position: absolute; padding: 4px; background: lightsteelblue; border-radius: 3px;")
					.style("opacity", 0);

				let plots = [
					{
						"name":"Probable",
						"legend": "Cumulative Probable Cases In The US To Date",
						"color": "#ffae6e"
					},
					{
						"name":"Resolved",
						"legend": "Cumulative Resolved Cases In The US To Date",
						"color": "#99ff8c"
					},
					{
						"name":"Active",
						"legend": "Present Number of Active (Contagious) Cases In The US",
						"color": "#ff506d"
					},
				];

				this.renderChart(plot_data, plots);

				let c1 = this.charts.population;
				this.addLegend(c1, plots, 20, 50);

				plots.forEach(function(plot){
					c1.append("path")
					.attr("d", getLine(plot['name'])(plot_data))
					.attr("stroke", plot['color'])
					.attr("stroke-width", 2)
					.attr("fill", "none");

					c1.selectAll("dot."+plot['name'])
						.data(plot_data)
						.enter().append("circle")
						.attr("fill-opacity",0)
						.attr("r", 5)
						.attr("cx", function(d) { return x_scale(t2d(d)); })
						.attr("cy", function(d) { return y_scale(d[plot['name']]); })
						.on("mouseover", function(d) {
							tooltip.transition()
								.duration(200)
								.style("opacity", 1);
							tooltip	.html(plot['name'] + "<br/>" + d['date'] + "<br/>"  + d[plot['name']])
								.style("left", (d3.event.pageX + 20) + "px")
								.style("top", (d3.event.pageY - 28) + "px");
						})
						.on("mouseout", function() {
							tooltip.transition()
								.duration(500)
								.style("opacity", 0.0);
						});
				});


				this.charts.population.attr("transform", "translate("+this.margins.left+","+this.margins.top+")");
				 */
			},

			renderChart_Growth(plot_data){


				let chart_width = this.width - this.margins.left - this.margins.right;
				let chart = this.charts.growth;
				let plot_name = "Growth Rate";
				let color = "#f7fffc";

				chart
					.attr("id", "growth_rate");

				function t2d(d){
					return new Date(d['timestamp']);
				}

				let x_scale = d3.scaleTime()
					.domain([d3.min(plot_data, t2d), d3.max(plot_data, t2d)])
					.range([0, chart_width]);

				let y_scale = d3.scaleLinear()
					.domain([0, 0.5])
					.range([this.chart_height, 0]);

				let growth_rate_ok = 0.035;
				let opacity = 0.5;
				this.charts.growth.append("rect")
					.attr("fill", "#abffac")
					.attr("opacity", opacity)
					.attr("width", chart_width)
					.attr("height", y_scale(0) - y_scale(growth_rate_ok))
					.attr("y", y_scale(growth_rate_ok));

				this.charts.growth.append("rect")
					.attr("fill", "#ff9e08")
					.attr("opacity", opacity)
					.attr("width", chart_width)
					.attr("height", y_scale(0) - y_scale(growth_rate_ok))
					.attr("y", y_scale(2*growth_rate_ok));

				this.charts.growth.append("rect")
					.attr("fill", "#ff0002")
					.attr("opacity", opacity)
					.attr("width", chart_width)
					.attr("height", y_scale(2*growth_rate_ok))
					.attr("y", y_scale());

				let x_axis = d3.axisBottom()
					.scale(x_scale);

				let y_axis = d3.axisLeft()
					.scale(y_scale);

				chart.append('g')
					.attr("transform", "translate(0," + this.chart_height + ")")
					.call(x_axis);

				chart.append('g').call(y_axis);

				let line = d3.line()
					.x(function (d) {
						return x_scale(t2d(d));
					})
					.y(function (d) {
						return y_scale(d[plot_name]);
					});


				var tooltip = d3.select("body").append("div")
					.attr("class", "tooltip")
					.attr("style", "position: absolute; padding: 4px; background: lightsteelblue; border-radius: 3px;")
					.style("opacity", 0);


				chart.append("path")
					.attr("d", line(plot_data))
					.attr("clip-path", "url(#growth_clip)")
					.attr("stroke", color)
					.attr("stroke-width", 2)
					.attr("fill", "none");

				chart.selectAll("dot.avoid")
					.data(plot_data)
					.enter().append("circle")
					.attr("fill-opacity",0)
					.attr("r", 5)
					.attr("cx", function(d) { return x_scale(t2d(d)); })
					.attr("cy", function(d) { return y_scale(d[plot_name]); })
					.on("mouseover", function(d) {
						tooltip.transition()
							.duration(200)
							.style("opacity", 1);
						tooltip	.html("Growth Rate <br/>" + d['date'] + "<br/>"  + d[plot_name])
							.style("left", (d3.event.pageX + 20) + "px")
							.style("top", (d3.event.pageY - 28) + "px");
					})
					.on("mouseout", function() {
						tooltip.transition()
							.duration(500)
							.style("opacity", 0.0);
					});

				this.addLegend(chart, [{'legend': "Growth Rate", 'color': color}], 250, 50);

				let y_translate = this.margins.top+this.chart_height+this.margins.bottom;
				chart.attr("transform", "translate("+this.margins.left+","+y_translate+")");
			},

			renderChart_Disruption(plot_data){
				let g = this.charts.disruption;

				let x_axis = d3.axisBottom()
					.scale(this.x_scale);

				g.append('g')
					.attr("transform", "translate(0," + this.chart_height + ")")
					.call(x_axis);

				let plots = [
					{
						"name": "Water Disruption",
						"legend": "Possible Water Disruption",
						"color": "#8fcbff"
					},
					{
						"name": "Food Disruption",
						"legend": "Possible Food Disruption",
						"color": "#728d3c"
					},
					{
						"name": "Power Disruption",
						"legend": "Possible Power Disruption",
						"color": "#d38013"
					},
					{
						"name": "Healthcare Disruption",
						"legend": "Possible Healthcare Disruption",
						"color": "#911304"
					}

				];

				let padding = 3;
				let height = this.chart_height/ 4 - padding;
				let d1 = new Date('2020-01-01');
				let d2 = new Date('2020-01-02');
				let rect_width = (this.x_scale(d2) - this.x_scale(d1)) * 0.8;
				let thys = this;
				plots.forEach(function(plot, index){
					g.selectAll('rect.'+plot['name'])
					.data(plot_data)
						.enter()
						.append("rect")
						.attr("class", plot['name'])
						.attr('x', function(d){
							return thys.x_scale(thys.t2d(d));
						})
						.attr('y', index * (height+padding))
						.attr('width', rect_width)
						.attr('height', height)
						.attr('fill', function(d){
							let color = (d[plot['name']]==1)?plot['color']:'transparent';
							return color;
						});
				});

				this.addLegend(g, plots, 20, 20);
				let y_translate = this.margins.top+2*(this.chart_height+this.margins.bottom);
				g.attr("transform", "translate("+this.margins.left+","+y_translate+")");


			},

			renderChart_Avoid(plot_data){

				let chart_width = this.width - this.margins.left - this.margins.right;
				let chart = this.charts.avoid;
				let plot_name = "Avoid Crowd Of";

				function t2d(d){
					return new Date(d['timestamp']);
				}

				let x_scale = d3.scaleTime()
					.domain([d3.min(plot_data, t2d), d3.max(plot_data, t2d)])
					.range([0, chart_width]);

				let y_scale = d3.scaleLinear()
					.domain([0, d3.max(plot_data, function (d) {
						return d[plot_name];
					})])
					.range([this.chart_height, 0]);

				let x_axis = d3.axisBottom()
					.scale(x_scale);

				let y_axis = d3.axisLeft()
					.scale(y_scale);

				chart.append('g')
					.attr("transform", "translate(0," + this.chart_height + ")")
					.call(x_axis);

				chart.append('g').call(y_axis);

				let line = d3.line()
					.x(function (d) {
						return x_scale(t2d(d));
					})
					.y(function (d) {
						return y_scale(d[plot_name]);
					});


				var tooltip = d3.select("body").append("div")
					.attr("class", "tooltip")
					.attr("style", "position: absolute; padding: 4px; background: lightsteelblue; border-radius: 3px;")
					.style("opacity", 0);


				chart.append("path")
					.attr("d", line(plot_data))
					.attr("stroke", "#fff975")
					.attr("stroke-width", 2)
					.attr("fill", "none");

				chart.selectAll("dot.avoid")
					.data(plot_data)
					.enter().append("circle")
					.attr("fill-opacity",0)
					.attr("r", 5)
					.attr("cx", function(d) { return x_scale(t2d(d)); })
					.attr("cy", function(d) { return y_scale(d[plot_name]); })
					.on("mouseover", function(d) {
						tooltip.transition()
							.duration(200)
							.style("opacity", 1);
						tooltip	.html("Avoid Crowd Of <br/>" + d['date'] + "<br/>"  + d[plot_name])
							.style("left", (d3.event.pageX + 20) + "px")
							.style("top", (d3.event.pageY - 28) + "px");
					})
					.on("mouseout", function() {
						tooltip.transition()
							.duration(500)
							.style("opacity", 0.0);
					});

				this.addLegend(chart, [{'legend': ">1% Chance of Exposure If You're In A Crowd Of...", 'color': "#fff975"}], 250, 50);

				let y_translate = this.margins.top+3*(this.chart_height+this.margins.bottom);
				chart.attr("transform", "translate("+this.margins.left+","+y_translate+")");
			},

			addLegend(chart_group, legend_values, x, y){
				let g = chart_group.append("g");

				let y_spacing = 20;
				let line_length = 20;
				let text_margin = 5;
				let line_adjust = -4;

				for(let i=0; i<legend_values.length; i++){
					legend_values[i]['x'] = 0;
					legend_values[i]['y'] = i * y_spacing;
				}

				let line = g.selectAll("line")
					.data(legend_values)
					.enter()
					.append("line");

				line
					.attr('x1', 0)
					.attr('y1', function(d){ return d['y']+line_adjust; })
					.attr('x1', line_length)
					.attr('y2', function(d){ return d['y']+line_adjust; })
					.attr("stroke", function(d){ return d['color']; })
					.attr("stroke-width", 2)
					.attr("fill", "none");

				let text = g.selectAll("text")
					.data(legend_values)
					.enter()
					.append("text");

				text
					.attr("x", function(d) { return d['x'] + line_length + text_margin; })
					.attr("y", function(d) { return d['y']; })
					.text( function (d) { return d['legend']; })
					.attr("font-family", "sans-serif")
					.attr("font-size", "12px")
					.attr("fill", function(d){ return d['color']});

				g.attr("transform", "translate("+x+","+y+")");


			}

		}
	}
</script>

<style lang="css" scoped>
	.tooltip{
		position: absolute;
		text-align: center;
		width: 60px;
		height: 28px;
		padding: 2px;
		font: 12px sans-serif;
		background: lightsteelblue;
		border: 0px;
		border-radius: 8px;
		pointer-events: none;
	}

</style>